package cwp.tags;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.*;
import javax.servlet.*;

/** A tag that acts like an if/then/else.
 *  <P>
 *  Taken from Core Servlets and JavaServer Pages
 *  from Prentice Hall and Sun Microsystems Press,
 *  http://www.coreservlets.com/.
 *  &copy; 2000 Marty Hall; may be freely used or adapted.
 */

public class IfTag extends TagSupport
{
  private boolean condition;
  private boolean hasCondition = false;

  public void setCondition(boolean condition)
  {
    this.condition = condition;
    hasCondition = true;
  }

  public boolean getCondition()
  {
    return(condition);
  }

  public void setHasCondition(boolean flag)
  {
    this.hasCondition = flag;
  }

  /** Has the condition field been explicitly set? */

  public boolean hasCondition()
  {
    return(hasCondition);
  }

  public int doStartTag()
  {
    return(EVAL_BODY_INCLUDE);
  }
}
