package cwp.tags;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import cwp.tags.*;


/** Sets six cookies: three that apply only to the current
 *  session (regardless of how long that session lasts)
 *  and three that persist for an hour (regardless of
 *  whether the browser is restarted).
 *  <P>
 *  Taken from Core Servlets and JavaServer Pages
 *  from Prentice Hall and Sun Microsystems Press,
 *  http://www.coreservlets.com/.
 *  &copy; 2000 Marty Hall; may be freely used or adapted.
 */

public class SetCookies extends HttpServlet {
  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
      throws ServletException, IOException {

    	Cookie cookie = new Cookie("username","mytestcookie");
    	response.addCookie(cookie);
    	//response.setHeader(cookie);

    response.setContentType("text/html");
    //response.setContentType(image/gif);
    //response.serContentType(application/vnd.ms-excel);
    PrintWriter out = response.getWriter();
    String title = "Setting Cookies";

    out.println("***This page sets the cookie value to cookie name (this is not included into the html)");

    out.println
      (ServletUtilities.headWithTitle(title) +
       "<BODY BGCOLOR=\"#FDF5E6\">\n" +
       "<H1 ALIGN=\"CENTER\">" + title + "</H1>\n" +
       "There are six cookies associated with this page.\n" +
       "To see them, visit the\n" +
       //"<A HREF=\"/examples/HelloWorldTag.jsp\">\n" +
       "<A HREF=\"/examples/servlet/cwp.tags.ShowCookies\">\n" +
       "<CODE>ShowCookies</CODE> servlet</A>.\n" +
       "<P>\n" +
       "Three of the cookies are associated only with the\n" +
       "current session, while three are persistent.\n" +
       "Quit the browser, restart, and return to the\n" +
       "<CODE>ShowCookies</CODE> servlet to verify that\n" +
       "the three long-lived ones persist across sessions.\n" +
       "</BODY></HTML>");
  }
}


